## Copyright (C) 2005 Roberto Ripio
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##

home; close;

# User Data----------------------------------------------------------------

# GS General Settings

GSFs=44100;				# GSFs Sampling Frequency
GSLExp=14;				# GSLExp Final filter length (exponent of 2) ej:14-> 32768 
GSSmoothWidth=6;		# GSSmoothWidth Points per octave for smoothing
GSTInit=0.1;			# Init time of impulse window (s)
GSTFinal=0.3;			# Final time of impulse window (s)


# FS File Settings

# FSInputFile .pcm file with impulse response (32 bits float mono)
FSInputFile="F:/P/TEMAS/AUDIO/Altavoces/Aurora/eq/woofer-sum-near-far.pcm";
FSOutPrefix="woofer_6ppo";			# FSOutPrefix Prefix for the name of output files
FSOutDir="";						# FSOutDir Output directory


# CF Crossover Filter

# Set to 0 if no crossover at that end
CFLowF=0 ;					# CFLowF Crossover point frequency Low (Hz)
CFHighF=4000;				# CFHighFF Crossover point frequency High (Hz)


# TW Transition Window

TWFlatInterval=1/3;			#Interval to be equalized flat beyond crossover frequency (octaves)
TWTransitionInterval=1;		#Interval of progressive elimination of equalization (octaves)
TWLimitLowF=100;			#Lmite a ecualizar plano (Low) (Hz)
TWLimitHighF=20000;			#Lmite a ecualizar plano (High) (Hz)

# PS Plot Settings
PSFLow=20;					# PSFLow, low frequency extreme for plotting
PSFHigh=5000;				# PSFHigh, high frequency extreme for plotting

# End user data------------------------------------------------------------
	
c0=343; %speed of sound
pi2=2*pi;
# index of GSTInit, GSTFinal
GSTInitK=floor(GSTInit*GSFs); GSTFinalK=floor(GSTFinal*GSFs);

# Longitud del fft (potencia de 2)
if (CFHighF != 0 | CFLowF != 0) # Crossover filter
	fft_l_exp=GSLExp-1;
else;
	fft_l_exp=GSLExp;
end;

# m, fft computation length
m=2^fft_l_exp;
m2=m/2;

ml=GSFs/m;	# low freq, freq jump
mh=m2*ml;	# max freq
rx=1:m2;	# indexes of non aliased frequency vector
mx=ml*rx;	# non aliased frequency vector

# m, fft computation length (tras la convolucin)
m_final=2^GSLExp;

m2_final=m_final/2;
ml_final=GSFs/m_final;		# low freq, freq jump
mh_final=m2_final*ml_final;	# max freq
rx_final=1:m2_final;		# indexes of non aliased frequency vector
mx_final=ml_final*rx_final;	# non aliased frequency vector

m_conv=2*m_final;

m2_conv=m_conv/2;
ml_conv=GSFs/m_conv;		# low freq, freq jump
mh_conv=m2_conv*ml_conv;	# max freq
rx_conv=1:m2_conv;			# indexes of non aliased frequency vector
mx_conv=ml_conv*rx_conv;	# non aliased frequency vector


t=(1:m)/GSFs; d=t*c0;

# reads impulse response from file
[fd1,err]=fopen(FSInputFile,"r"); [aax, file_size]=fread(fd1, Inf, "float"); fclose(fd1);
# index of GSTInit, GSTFinal
GSTInitK=floor(GSTInit*GSFs); GSTFinalK=floor(GSTFinal*GSFs);
if GSTFinalK>file_size GSTFinalK=file_size; end;
aax=aax(GSTInitK:GSTFinalK);
[na,k0]=size(aax);
ninitial=na; # ntinitial=na; nlinitial=1;
clear na k0
# calculate LS impulse response vectors am of normalised length m
if ninitial>m-1
	ninitial=m-1;
	am=aax(1:m);
else
	am=aax; am=[am; zeros(size(ninitial+1:m))'];
end
a=am; aa=aax; # trimmed impulse of lenght m, original impulse
clear am aax;

## Clculo de la respuesta a invertida

#Clculo de la ventana de transicin
if CFLowF==0
	TWLowK2=round(TWLimitLowF/ml);
	TWLowF1=TWLimitLowF/(2^TWTransitionInterval);
	CFLowK=TWLowK2;
else
	TWLowF2=CFLowF/(2^TWFlatInterval);
	TWLowK2=round(TWLowF2/ml);
	TWLowF1=TWLowF2/(2^TWTransitionInterval);
	CFLowK=round(CFLowF/ml);
end
if TWLowF1<ml TWLowK1=1; else TWLowK1=round(TWLowF1/ml); end;

if CFHighF==0
	TWHighK1=round(TWLimitHighF/ml);
	TWHighF2=TWLimitHighF*(2^TWTransitionInterval);
	CFHighK=TWHighK1;
else
	TWHighF1=CFHighF*(2^TWFlatInterval);
	TWHighK1=round(TWHighF1/ml);
	TWHighF2=TWHighF1*(2^TWTransitionInterval);
	CFHighK=round(CFHighF/ml);
end
if TWHighF2>mh TWHighK2=m2; else TWHighK2=round(TWHighF2/ml); end;

# calculate frequency response
aH=fft(a); amag=abs(aH);
amag_smooth=sqrt(smooth(amag .^ 2, GSSmoothWidth));
anormfactor=max(amag_smooth(CFLowK:CFHighK));
amag_smooth=amag_smooth / anormfactor; # Normaliza la respuesta al mximo en la banda
a=a/anormfactor; # Normaliza el impulso segn la respuesta
	
amag_dB=20*log10(amag_smooth);


TWLowdB=amag_dB(TWLowK2+1);
TWHighdB=amag_dB(TWHighK1-1);

#TFR Target Frequency Response
TFRFlatLow=ones(TWLowK1-1,1)*TWLowdB;
TFRFlatHigh=ones(m2-TWHighK2,1)*TWHighdB;
TFRTransitionLow=blackman((TWLowK2-TWLowK1+1)*2)(1:TWLowK2-TWLowK1+1);
TFRTransitionLow=TFRTransitionLow .* amag_dB(TWLowK1:TWLowK2)+...
				(1-TFRTransitionLow)*TWLowdB;
TFRTransitionHigh=blackman((TWHighK2-TWHighK1+1)*2)(TWHighK2-TWHighK1+2:((TWHighK2-TWHighK1+1)*2));
TFRTransitionHigh=TFRTransitionHigh .* amag_dB(TWHighK1:TWHighK2)+...
				(1-TFRTransitionHigh)*TWHighdB;
TFRdB=[TFRFlatLow;TFRTransitionLow;amag_dB(TWLowK2+1:TWHighK1-1);TFRTransitionHigh;TFRFlatHigh];
TFRMag=10.^(TFRdB/20);
TFRMag=1 ./ TFRMag; # Inversin de la respuesta

TFRMag=TFRMag / max(TFRMag(CFLowK:CFHighK)); # Normaliza la respuesta (slo atena)

#Target Frequency Response Minimum Phase
TFRMag=[TFRMag(1:m2); TFRMag(m2); conj(TFRMag(m2:-1:2))];

#Target Impulse Minimum Phase
TFRImpMP=real(ifft(exp(conj(hilbert(log(TFRMag))))));

# CF Crossover Filter
# CFLowN y CFHighN , frecuencias de corte normalizadas [0,1]
CFLowN=CFLowF/(GSFs/2); CFHighN=CFHighF/(GSFs/2);

if (CFHighF != 0 | CFLowF != 0) # Crossover filter
	if (CFHighF == 0 & CFLowF != 0) # high-pass filter
		CFImp=fir1(m,CFLowN,'high','blackman','scale');
	elseif (CFHighF != 0 & CFLowF == 0) # low-pass filter
		CFImp=fir1(m,CFHighN,'low','blackman','scale');
	elseif (CFHighF != 0 & CFLowF != 0) # band-pass filter
		CFImp=fir1(m,[CFLowN,CFHighN],'pass','blackman','scale');
	end;
	TFRImpFinal=conv(TFRImpMP,CFImp);
else;
	TFRImpFinal=TFRImpMP;
end;


#Guarda el filtro completo
savepcm(TFRImpFinal, [FSOutPrefix '.pcm']);

#Guarda el resultado final
TFRImpConv=conv(TFRImpFinal,a)';
savepcm(TFRImpConv,[FSOutPrefix '_conv.pcm']);

TFRImpConvPlot=zeros(m_conv,1);
TFRImpConvSize=size(TFRImpConv,1);
TFRImpConvPlot(1:TFRImpConvSize)=TFRImpConv;



#-----------------------------------------------------------------------------------------
# Plotting

# Disable automatic replot
automatic_replot = 0;
	
# Set terminal to unknown for initial simulated plotting postscript eps
__gnuplot_raw__('set terminal unknown;\n');


# plots magnitude responses

title(FSOutPrefix);

grid('on');

	__gnuplot_raw__('set xlabel "Frequency (KHz)" 0;\n');
	__gnuplot_raw__('set ylabel "Magnitude (dB)" 0;\n');
	__gnuplot_raw__(strcat('set xrange [', num2str(PSFLow/1000), ':' ,num2str(PSFHigh/1000), '];\n'));
	__gnuplot_raw__('set xtics (0.01,0.02,0.03,0.05,0.1,0.2,0.3,0.5,1,2,3,5,10,20);\n');
	__gnuplot_raw__('set yrange [-30:3];\n');
	__gnuplot_raw__('set ytics -30,3,18;\n');
	__gnuplot_raw__('set key right top;\n');
	
hold off;
# plots filter response
semilogx(mx_final/1000,20*log10(abs(fft(TFRImpFinal)))(rx_final),strcat("1",";",'filtro',";"));
hold on;
# plots original response
semilogx(mx/1000,amag_dB (rx),strcat("2",";",'original',";"));
# plots final response
semilogx(mx_conv/1000,20*log10(abs(fft(TFRImpConvPlot)))(rx_conv),strcat("3",";",'resultado',";"));
hold off;

# Set terminal to windows for the real plotting
__gnuplot_raw__('set terminal windows;\n');
# Performs the real plot
replot;

# Set terminal to postscript eps for the real plotting
__gnuplot_raw__('set terminal postscript eps color solid linewidth 1 rounded;\n');
# Set output file
__gnuplot_raw__([ 'set output ' '"' FSOutDir FSOutPrefix '.eps' '"' '\n' ]);
# Performs the real plot
replot;

# Set terminal to png for the real plotting
__gnuplot_raw__('set terminal png size 800,600;\n');
# Set output file
__gnuplot_raw__([ 'set output ' '"' FSOutDir FSOutPrefix '.png' '"' '\n' ]);
# Performs the real plot
replot;

# Reset output file
__gnuplot_raw__('set output;\n');

# Reset the terminal to windows
__gnuplot_raw__('set terminal windows;\n');