## Copyright (C) 2005 Roberto Ripio
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##

home; clear; close all;
#---------------------------------------------------------------------------------------
# Datos de usuario


# GS General Settings

GSFs=44100;				# GSFs Frecuencia de muestreo
GSLExp=14;				# GSLExp Final filter length (exponent of 2) ej:14-> 32768 
GSSmoothWidth=3;		# GSSmoothWidth Points per octave for smoothing
GSa=0.075;				# Loudspeaker cone radius (include ~1/3 of surround)  (m)

# FF Far Field

FFTInit=0.1;			# Init time of impulse window (s)
FFTFinal=0.1053;		# Final time of impulse window (s)
FFr=1;					# Far Field measure distance (m)
FFV=2.79;				# Far field RMS voltage (v)

# CF Crossover Filter

CFAtt=100;				# Attenuation at the extremes of the common band 

# FS File Settings

# FSFFInputFile .pcm impulse file Far Field
FSFFInputFile="F:/P/TEMAS/AUDIO/Altavoces/Aurora/mediciones/woofer-fieltro-0.Fs=44100.imp";
# FSNFInputFile pcm impulse file  Near Field
FSNFInputFile="F:/P/TEMAS/AUDIO/Altavoces/Aurora/mediciones/woofer-near-12.Fs=44100.imp";
FSOutPrefix="woofer_combo";	# FSOutPrefix Prefix for the name of output files
FSOutDir="";				# FSOutDir Output directory

# SW Smoothing Window 
SWL=20; # SWL Smoothing window length for truncation (samples)

# PS Plot Settings
PSFLow=20;					# PSFLow, low frequency extreme for plotting
PSFHigh=20000;				# PSFHigh, high frequency extreme for plotting

#---------------------------------------------------------------------------------------
# Fin datos de usuario

c0=343;

FFMinF=1/(FFTFinal-FFTInit-(FFr/c0))	# Far Field Frecuencia mnima vlida
FFP = GSa/2/FFr;						# ?
FFPdB = 20*log10(GSa)

NFMaxF = c0 / (2 * pi * GSa)	# Near Field Frecuencia mxima vlida
NFMaxD = 0.11 * GSa				# Near Field Distancia mxima del micro

# m, fft computation length
m=2^GSLExp;
m2=m/2;

ml=GSFs/m;	# low freq, freq jump
mh=m2*ml;	# max freq
Fk=1:m2;	# indexes of non aliased frequency vector
F=ml*Fk;	# non aliased frequency vector

# Crossover Filter (Linkwitz-Riley de fase lineal)
CFFc = 	FFMinF * sqrt(NFMaxF/FFMinF)	# Crossover filter Fc
CFFcK = round(CFFc/ml);
CFSlope= CFAtt / (log(sqrt(NFMaxF/FFMinF)) / log(2))
CFK=CFSlope / (20*log10(2)) / 2;

CFMagL = (1 ./ (1 +((F ./ CFFc) .^ (2*CFK))))'; # Filtro Linkwitz-Riley
CFMagH = (((F ./ CFFc) .^ (2*CFK)) ./ (1 + ((F ./ CFFc) .^ (2*CFK))))';

CFMagL = [CFMagL(1:m2); CFMagL(m2); conj(CFMagL(m2:-1:2))];
CFImpL = fftshift(real(ifft(CFMagL)));
CFMagH = [CFMagH(1:m2); CFMagH(m2); conj(CFMagH(m2:-1:2))];
CFImpH = fftshift(real(ifft(CFMagH)));


# index of FFTInit, FFTFinal
FFTInitK=floor(FFTInit*GSFs); FFTFinalK=floor(FFTFinal*GSFs); FFLength=FFTFinalK-FFTInitK+1;

FFImp = loadpcm(FSFFInputFile);
NFImp = loadpcm(FSNFInputFile);

# Alinea en tiempo NF con FF
[max1,k1] = max(abs(hilbert(FFImp))); [max2,k2] = max(abs(hilbert(NFImp)));
NFImpDelay = k1-k2
NFImp = postpad([zeros(NFImpDelay,1);NFImp], length(FFImp)); 

# Ventanas y padding
SW = [(1+cos(pi*(SWL:-1:1)/SWL))/2 ones(size(FFTInitK+SWL:FFTFinalK-SWL)) (1+cos(pi*(1:SWL)/SWL))/2]'; # Hann?
FFImpW = postpad((FFImp(FFTInitK:FFTFinalK) .* SW), m);

NFImpW = NFImp(FFTInitK:length(NFImp));
SW = [(1+cos(pi*(SWL:-1:1)/SWL))/2 ones(size(1+SWL:length(NFImpW)))]'; # Ventana de suavizado inicial
NFImpW = NFImpW .* SW;


if length(NFImpW) > m
	NFImpW = postpad(NFImpW, m);
	SW=[ones(size(1:length(NFImpW)-SWL)) (1+cos(pi*(1:SWL)/SWL))/2]'; # Hann?
	NFImpW = NFImpW .* SW;
else
	SW=[ones(size(1:length(NFImpW)-SWL)) (1+cos(pi*(1:SWL)/SWL))/2]'; # Hann?
	NFImpW = postpad((NFImpW .* SW), m);
end

# Magnitud de las respuestas
FFMag = abs(fft(FFImpW));
NFMag = abs(fft(NFImpW));

# Magnitud suavizada a la frecuencia de corte
SmoothL = 2^( 0.5 / GSSmoothWidth );
SmoothK = (floor(CFFcK /SmoothL): floor(CFFcK * SmoothL));

FFMagFc = sqrt(sum(FFMag(SmoothK) .^ 2) ./ length(SmoothK));
NFMagFc = sqrt(sum(NFMag(SmoothK) .^ 2) ./ length(SmoothK));

# Escala los impulsos y magnitud Near Field
NFImp = (FFMagFc/NFMagFc) .* NFImp;
NFMag = (FFMagFc/NFMagFc) .*  NFMag;

# Prepara el impulso Far Field
FFImpW = postpad([zeros(FFTInitK-1, 1); FFImpW], length(FFImp));

# Filtra los impulsos
NFImpW = fftconv(CFImpL, NFImp);
FFImpW = fftconv(CFImpH, FFImpW);

SumImp = NFImpW + FFImpW;
SumImp = SumImp(m2+1:m2+length(NFImp));
SumMag = abs(fft(SumImp, m));

# Guarda el filtro
savepcm(SumImp, [FSOutPrefix '.imp']);

# Debug
# hold off; plot(NFImpW); hold on; plot(FFImpW); plot(SumImp); hold off;

#-----------------------------------------------------------------------------------------
# Plotting

# Disable automatic replot
automatic_replot = 0;
	
# Set terminal to unknown for initial simulated plotting postscript eps
__gnuplot_raw__('set terminal unknown;\n');


# plots magnitude responses

title(FSOutPrefix);

grid('on');

	__gnuplot_raw__('set xlabel "Frequency (KHz)" 0;\n');
	__gnuplot_raw__('set ylabel "Magnitude (dB)" 0;\n');
	__gnuplot_raw__(strcat('set xrange [', num2str(PSFLow/1000), ':' ,num2str(PSFHigh/1000), '];\n'));
	__gnuplot_raw__('set xtics (0.01,0.02,0.03,0.05,0.1,0.2,0.3,0.5,1,2,3,5,10,20);\n');
	__gnuplot_raw__('set yrange [-30:3];\n');
	__gnuplot_raw__('set ytics -30,3,18;\n');
	__gnuplot_raw__('set key right top;\n');
	
hold off;

# plots NearField response
semilogx(F/1000,20*log10(NFMag(Fk)),strcat("1",";",'Near Field',";"));
hold on;
# plots original response
semilogx(F/1000,20*log10(FFMag(Fk)),strcat("2",";",'Far Field',";"));
semilogx(F/1000,20*log10(SumMag(Fk)),strcat("3",";",'Sum',";"));
semilogx(F/1000,20*log10(CFMagL(Fk)),strcat("4",";",'LP Filter',";"));
semilogx(F/1000,20*log10(CFMagH(Fk)),strcat("5",";",'HP Filter',";"));

hold off;

# Set terminal to windows for the real plotting
__gnuplot_raw__('set terminal windows;\n');
# Performs the real plot
replot;

# Set terminal to postscript eps for the real plotting
__gnuplot_raw__('set terminal postscript eps color solid linewidth 1 rounded;\n');
# Set output file
__gnuplot_raw__([ 'set output ' '"' FSOutDir FSOutPrefix '.eps' '"' '\n' ]);
# Performs the real plot
replot;

# Set terminal to png for the real plotting
__gnuplot_raw__('set terminal png size 800,600;\n');
# Set output file
__gnuplot_raw__([ 'set output ' '"' FSOutDir FSOutPrefix '.png' '"' '\n' ]);
# Performs the real plot
replot;

# Reset output file
__gnuplot_raw__('set output;\n');
